/****************************************************************************
*
*	  Header Filename:  Form_View_Chemistry.h
*	  Module Name:      Form_View_Chemistry
*	  Description:      View Chemistry
*	  Author:           Chris Gordon-Smith
*
*     Copyright (C) 2003, 2004, 2005, 2006, 2008 Chris Gordon-Smith
*     Email: See http://www.simsoup.info/
*
*     This program is free software; you can redistribute it and/or modify it
*     under the terms of the GNU General Public License Version 2, as published 
*     by the Free Software Foundation.
*
*     This program is distributed in the hope that it will be useful, but
*     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
*     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*     for more details.
*
*     You should have received a copy of the GNU General Public License along
*     with this program; if not, write to the Free Software Foundation, Inc.,
*     59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*     See the file Licence.txt for a copy of the GNU General Public License.
*
*	  Amendment History:-
*
*		Version	   Date	   			Update Description
*		=======    ===========		==================
*
*
*
*
****************************************************************************/

#ifndef Form_View_Chemistry_H
#define Form_View_Chemistry_H


#include    "Form_View_Network.h" // Inherited class

class   Chemistry;
class   Molecule_Type;

class TForm__View_Chemistry : public TForm__View_Network
{

    private:
//===== Relationships with other classes =====================================================================================
//        Chemistry* Chemistry__Ptr;
//==========================================================================================================================


    public:
        TForm__View_Chemistry();
        static void  Make();

        static  void  Show_Chemistry(int Number_Of_Nodes);
        static  TForm__View_Chemistry*  Get_Ptr() {return Form_Ptr;}
        void    List_Nodes() const;
        bool    Is_On_Active_Page();
        void    Notify_MolType_ListView_Selection(void*  Data_Ptr);

    private:

//      Private Data

        static TForm__View_Chemistry*  Form_Ptr;  // Pointer to an Open View
                                                  // Set zero if no open View                                          


//      Private Functions
 
        void    Add_Node() const;
        void    Remove_Node() const;

        void    Close_View();

        void    Add_Item_Of_Node_Type() const;

        Molecule_Type*    Get_Selected_Mol_Type() const;
        
        void    Draw_Connection(void* Void__Interaction_Ptr,
                     int Conn_Selection_State) const;
        void    Draw_Node(void* Void__Molecule_Type_Ptr) const;
        void    Draw_All_Connections() const;
        void    Draw_All_Nodes() const;
        void    Draw_Selected_Nodes() ;
        void    Draw_Text_Output() const;
        void    List_Connections_For_Node(Molecule_Type* Node_Ptr) const;
        
//        TListView* Get_Laz_ListView_Connections_Ptr();
//        TPairSplitter* Get_Laz_ListView_PairSplitter_Ptr();
//        TListView* Get_Laz_ListView_Nodes_Ptr();
//        TTabSheet* Get_Laz_TabSheet_Ptr();
//        TPaintBox* Get_Laz_PaintBox_Ptr();
            
        int     Compare_Nodes(void*  Node1_Ptr, void* Node2_Ptr) const;
        int     Compare_Connections(void*  Connect1_Ptr, void* Connect2_Ptr) const;

        void    Get_Conns_Matching_Node_And_Type
                                        (list<void*>& List_Of_Connections,
                                         int  Node_Index,
                                         Enum_Node_Selection_State Selection_State);
        int     Get_Number_Of_Possible_Nodes();

        void    Remove_And_Replace_Connections(int Old_Node_Index, int Current_Node_Index);
};
#endif  //Form_View_Chemistry_H
